image: maven

cache:
  key: "$CI_COMMIT_REF_NAME"   # Key for the cache, based on the branch name
  paths:
    - .m2/repository/         # Maven local repository

default:
  timeout: 30m  # Set the default timeout to 5 minutes

workflow:
  rules:
    - if: $CI_COMMIT_TITLE =~ /-draft$/
      when: never
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
    - changes: 
      - '*'
      - '!docs/*'
      - '!README.md'

stages:          # List of stages for jobs, and their order of execution
  - build
  - test
 

build-job:       # This job runs in the build stage, which runs first.
  stage: build
  script:
    - echo "Compiling the code..."
    - mvn -version
    - mvn compile
    - echo "Compile complete."
  interruptible: true

checkstyle:     #Checkstyle to enforce coding standards and conventions (e.g. whitespace, Javadoc)
  stage: test
  script:
    - mvn checkstyle:check
  artifacts:
    when: always
    paths:
      - target/checkstyle-result.xml
  interruptible: true

pmd:          #PMD for finding patterns that can lead to bugs (e.g. unused variables)
  stage: test
  script:
    - mvn pmd:check
  artifacts:
    when: always
    paths:
      - target/pmd.xml
  interruptible: true

vfy:          #PMD for finding patterns that can lead to bugs (e.g. unused variables)
  stage: test
  script:
    - mvn verify
  artifacts:
    when: always
    paths:
      - "target/site/jacoco/"
  interruptible: true

variables:
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
sonarcloud-check:
  image: maven # Or newer
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - mvn verify sonar:sonar -Dsonar.projectKey=joselito.serrano_basicmath_gl
  only:
    - merge_requests
    - main
    - develop
  interruptible: true
